<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <body>
  <h2>Book and article collection</h2>
  <table border="1">
  <tr><th>Title</th><th>Author(s)</th></tr>
  <xsl:apply-templates/>
  </table>
  </body>
  </html>
</xsl:template>

<xsl:template match="bib">
  <xsl:apply-templates select="book|paper"/>
</xsl:template>

<xsl:template match="book">
  <tr>
    <td>
      <xsl:apply-templates select="title"/>
    </td>
    <td>
      <xsl:apply-templates select="author"/>
    </td>
  </tr>
</xsl:template>

<xsl:template match="paper">
  <tr>
    <td>
      <span style="color:#ff0000"><xsl:apply-templates select="title"/></span>
    </td>
    <td>
      <span style="color:#ff0000"><xsl:apply-templates select="author"/></span>
    </td>
  </tr>
</xsl:template>

<xsl:template match="title">
  <span style="font-style:italic"><xsl:value-of select="."/></span>
</xsl:template>

<xsl:template match="author"> 
  <xsl:value-of select="last"/><xsl:if test="position()!=last()"><xsl:text>, </xsl:text></xsl:if>
</xsl:template>

</xsl:stylesheet>
